## qtmir 0.8.0~git20250407.ea2f477

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(qtmir)

set(QTMIR_VERSION_MAJOR 0)
set(QTMIR_VERSION_MINOR 8)
set(QTMIR_VERSION_PATCH 0)

set(QTMIR_VERSION ${QTMIR_VERSION_MAJOR}.${QTMIR_VERSION_MINOR}.${QTMIR_VERSION_PATCH})

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt and CMakeFiles/ from source root and try again.")
endif()

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

find_package (ECM 1.7.0 QUIET NO_MODULE)
if (ECM_FOUND)
    # Provides us with -DECM_ENABLE_SANITIZERS='X'
    # Where X can be address, thread, memory, leak, undefined
    include("${ECM_MODULE_DIR}/ECMEnableSanitizers.cmake")
endif()

# add custom cmake modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99 -Wall -Wextra")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -fno-strict-aliasing -Wextra")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")

set (CMAKE_CXX_STANDARD 20)

if ("${CMAKE_CXX_COMPILER}" MATCHES "clang")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type-c-linkage -Wno-mismatched-tags -Wno-inconsistent-missing-override -Wno-implicit-exception-spec-mismatch -Wno-unknown-pragmas")
endif()


#find_package(CoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )
    ENABLE_COVERAGE_REPORT(TARGETS ${SHELL_APP} FILTER /usr/include ${CMAKE_SOURCE_DIR}/tests/* ${CMAKE_BINARY_DIR}/*)
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks
add_custom_target(cppcheck COMMAND cppcheck --enable=all -q --error-exitcode=2
                                       ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/tests)

option(WITH_CONTENTHUB "Build with lomiri-content-hub" OFF)
option(WITH_VALGRIND "Build with Valgrind detection" ON)
option(WITH_MIR2 "Build with mir 2.x" OFF)

include(FindPkgConfig)
find_package(Qt5Core 5.9 REQUIRED)
find_package(Qt5DBus 5.9 REQUIRED)
find_package(Qt5Gui 5.9 REQUIRED)
find_package(Qt5Qml 5.9 REQUIRED)
find_package(Qt5Quick 5.9 REQUIRED)
find_package(Qt5Sensors 5.9 REQUIRED)
find_package(Qt5Test 5.9 REQUIRED)

find_package(Threads REQUIRED)

pkg_check_modules(MIRSERVER mirserver>=0.26 REQUIRED)
if(WITH_MIR2)
pkg_check_modules(MIRSERVER mirserver REQUIRED)
pkg_check_modules(MIROIL miroil REQUIRED)
else()
pkg_check_modules(MIRCLIENT mirclient>=0.26 REQUIRED)
endif()
pkg_check_modules(MIRRENDERERGLDEV mir-renderer-gl-dev>=0.26 REQUIRED)
pkg_check_modules(MIRAL miral>=1.1.0 REQUIRED)
pkg_check_modules(MIRWAYLAND mirwayland REQUIRED)
pkg_check_modules(WAYLAND_CLIENT REQUIRED wayland-client)
pkg_check_modules(WAYLAND_SERVER REQUIRED wayland-server)

pkg_check_modules(XKBCOMMON xkbcommon REQUIRED)
pkg_check_modules(GLIB glib-2.0 REQUIRED)
pkg_check_modules(PROCESS_CPP process-cpp REQUIRED)
pkg_check_modules(LOMIRI_APP_LAUNCH lomiri-app-launch-0 REQUIRED)
pkg_check_modules(URL_DISPATCHER lomiri-url-dispatcher REQUIRED)
pkg_check_modules(EGL egl)
pkg_check_modules(GIO gio-2.0)
pkg_check_modules(GIO_UNIX gio-unix-2.0)
pkg_check_modules(LTTNG lttng-ust)
pkg_check_modules(GSETTINGS_QT REQUIRED gsettings-qt)
pkg_check_modules(QTDBUSTEST libqtdbustest-1 REQUIRED)
pkg_check_modules(QTDBUSMOCK libqtdbusmock-1 REQUIRED)
pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=28)

if(WITH_VALGRIND)
    pkg_check_modules(VALGRIND valgrind REQUIRED)
    add_definitions(-DWITH_VALGRIND)
endif()

if(WITH_CONTENTHUB)
pkg_check_modules(CONTENT_HUB liblomiri-content-hub>=1.0.0 REQUIRED)
message(STATUS "Bulding with lomiri-content-hub")
endif()

include_directories(SYSTEM ${APPLICATION_API_INCLUDE_DIRS})

# Disable all deprecated qt functions in and before qt version 5.9
add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x050900)

# Use the fast string builder
add_definitions(-DQT_USE_QSTRINGBUILDER)

if (DEFINED USE_OPENGLES OR DEFINED USE_OPENGL_BUT_LINK_AGAINST_OPENGLES)
    message(DEPRECATION "USE_OPENGLES and USE_OPENGL_BUT_LINK_AGAINST_OPENGLES is no longer used as QtMir no longer links directly to libGL or libGLES.")
endif ()

# Standard install paths
include(GNUInstallDirs)


# Determine QPA plugin install path
# FIXME(greyback) there must be a better way than calling a private macro to set a property.
# I'm manually calling a macro from Qt5GuiConfig.cmake, but I don't understand why it isn't being called.
if (Qt5Gui_VERSION VERSION_LESS 5.14.0)
  _populate_Gui_plugin_properties("Gui" "PLATFORMS" "platforms")
else()
  _populate_Gui_plugin_properties("Gui" "PLATFORMS" "platforms" FALSE)
endif()
get_target_property(Qt5Gui_QPA_Plugin_Path Qt5::Gui IMPORTED_LOCATION_PLATFORMS)

# Set QML module install path
set(QML_MODULE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/qt5/qml")
set(QTMIR_DATA_DIR ${CMAKE_INSTALL_DATADIR}/qtmir)


# Customisations for the build type
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
    set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if(cmake_build_type_lower MATCHES relwithdebinfo) # workaround for http://public.kitware.com/Bug/view.php?id=14696
    add_definitions(-DQT_NO_DEBUG)
endif()
if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Werror")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()


# Mir uses boost, which does not like Qt defining macros named "signals" and "slots"
add_definitions(-DQT_NO_KEYWORDS)

# Tests
if (NO_TESTS OR WITH_MIR2)
    message(STATUS "Tests disabled")
else()
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
endif()

# add subdirectories to build
add_subdirectory(src)
add_subdirectory(demos)
add_subdirectory(benchmarks)
add_subdirectory(data)

=== benchmarks/CMakeLists.txt ===
file(GLOB BENCHMARK_FILES
	*.py
	*.R
)

install(FILES ${BENCHMARK_FILES}
    DESTINATION ${QTMIR_DATA_DIR}/benchmarks
)

=== tests/CMakeLists.txt ===
find_package(GMock)

include_directories(
    include
)

pkg_check_modules(MIRTEST mirtest>=0.26 REQUIRED)

add_subdirectory(framework)
add_subdirectory(mirserver)
add_subdirectory(modules)

add_test(
    NAME requires-provides
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/check-requires-provides.sh
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

=== demos/qtmir-demo-client/CMakeLists.txt ===
set(DEMO_CLIENT qtmir-demo-client)
configure_file(${DEMO_CLIENT}.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/${DEMO_CLIENT}.desktop @ONLY)

include_directories(
    SYSTEM
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
)

add_executable(${DEMO_CLIENT}
    main.cpp
)

target_link_libraries(
    ${DEMO_CLIENT}
    Qt5::Core
    Qt5::DBus
    Qt5::Qml
    Qt5::Quick
)

file(GLOB QML_JS_FILES *.qml *.js *.png)

add_custom_target(${DEMO_CLIENT}-qmlfiles
                  SOURCES ${QML_JS_FILES})

# install binaries
install(TARGETS ${DEMO_CLIENT}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
 )

install(FILES
    ${QML_JS_FILES}
    DESTINATION ${QTMIR_DATA_DIR}/${DEMO_CLIENT}
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${DEMO_CLIENT}.desktop
    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications
)

=== src/modules/CMakeLists.txt ===
find_package(QmlPlugins)

# Set up and install a QML plugin.
#
# add_qml_plugin(plugin version path
#     [...]  # See export_qmlfiles and export_qmlplugin documentation for more options
# )

macro(add_qml_plugin PLUGIN VERSION PATH)
    export_qmlfiles(${PLUGIN} ${PATH} DESTINATION ${QML_MODULE_INSTALL_DIR} ${ARGN})
    export_qmlplugin(${PLUGIN} ${VERSION} ${PATH} DESTINATION ${QML_MODULE_INSTALL_DIR} ${ARGN})
endmacro()

add_subdirectory(QtMir)

=== src/modules/QtMir/CMakeLists.txt ===
add_subdirectory(Application)

=== src/platforms/mirserver/CMakeLists.txt ===
# Qt5PlatformSupport is not available as a cmake module.
# And also not anymore as pkgconfig module since Qt 5.6.
#pkg_check_modules(QT5PLATFORM_SUPPORT Qt5PlatformSupport REQUIRED)
include(FindQt5PlatformSupport)
include(UseLttngGenTp)

set(QTMIRSERVER_ABI 2)

set(qtmir_include ${CMAKE_SOURCE_DIR}/include)

if(NOT WITH_MIR2)
  set(MIROIL_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/miroil/include)
  add_subdirectory(miroil)
endif()

add_subdirectory(wayland-generated)

# Hacks for the QPA privates monster.
pkg_check_modules(FONTCONFIG fontconfig REQUIRED)

if (QGL_DEBUG)
    message(STATUS "Qt's OpenGL debug logging enabled.")
    add_definitions(-DQGL_DEBUG)
endif()

if (WITH_CONTENTHUB)
    add_definitions(-DWITH_CONTENTHUB)
endif()

#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -fPIC")

find_package(Qt5FontDatabaseSupport REQUIRED)
find_package(Qt5ThemeSupport REQUIRED)
find_package(Qt5EventDispatcherSupport REQUIRED)
find_package(Qt5EglSupport REQUIRED)
find_package(Qt5ServiceSupport REQUIRED)
set(QT5PLATFORMSUPPORT_LIBS
    Qt5FontDatabaseSupport::Qt5FontDatabaseSupport
    Qt5ThemeSupport::Qt5ThemeSupport
    Qt5EventDispatcherSupport::Qt5EventDispatcherSupport
    Qt5EglSupport::Qt5EglSupport
    Qt5ServiceSupport::Qt5ServiceSupport
)

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/src/common
    ${CMAKE_CURRENT_BINARY_DIR} # for tracepoints.h
)

set(MIRCOMMON_INCLUDE_DIRS /usr/include/mircommon/)
set(MIRCOMMON_LDFLAGS "-lmircommon")

include_directories(
    SYSTEM
    ${MIRAL_INCLUDE_DIRS}
    ${MIRCOMMON_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIROIL_INCLUDE_DIRS}
    ${MIRWAYLAND_INCLUDE_DIRS}

    ${URL_DISPATCHER_INCLUDE_DIRS}
    ${EGL_INCLUDE_DIRS}
    ${LTTNG_INCLUDE_DIRS}

    ${Qt5Gui_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}


    ${Qt5Quick_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_INCLUDE_DIRS}

    ${APPLICATION_API_INCLUDE_DIRS}

if(WITH_CONTENTHUB)
    ${CONTENT_HUB_INCLUDE_DIRS}
endif()

    ${VALGRIND_INCLUDE_DIRS}
)

# We have to remove -pedantic for tracepoints.c
string (REPLACE " -pedantic " " " TRACEPOINTS_CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
# BYTE_ORDER needed to compile tracepoints in C99 mode.
set(TRACEPOINTS_CMAKE_C_FLAGS "${TRACEPOINTS_CMAKE_C_FLAGS} -DBYTE_ORDER=__BYTE_ORDER -fPIC ")
set_source_files_properties(tracepoints.c PROPERTIES COMPILE_FLAGS "${TRACEPOINTS_CMAKE_C_FLAGS}")

# Generate tracepoints.c and .h from tracepoints.tp
add_lttng_gen_tp(NAME tracepoints)
add_custom_target(MirServer_LTTNG
    DEPENDS tracepoints.h tracepoints.c
)

if(WITH_CONTENTHUB)
    set(CLIPBOARD_SRC clipboard.cpp)
endif()

# These files will compile without mirserver-dev
add_library(qtmirserver-nomirserver OBJECT
    ${CMAKE_SOURCE_DIR}/src/common/timestamp.cpp
    ${CLIPBOARD_SRC}
    logging.cpp
    shelluuid.cpp
    mirsingleton.cpp
    wrappedsessionauthorizer.cpp
    promptsessionlistener.cpp
    displayconfigurationstorage.cpp
    nativeinterface.cpp
    services.cpp
    urlbuilderdispatcher.cpp
    windowcontroller.cpp
    workspacecontroller.cpp
    tracepoints.c
    surfaceobserver.cpp
    initialsurfacesizes.cpp
    orientationsensor.cpp
    screenadaptor.cpp
    screenadaptormodel.cpp
    qtmir.cpp
)
add_dependencies(qtmirserver-nomirserver MirServer_LTTNG)

include_directories(SYSTEM ${MIRSERVER_INCLUDE_DIRS})

# These files will only compile with mirserver-dev
add_library(qtmirserver-mirserver OBJECT
    screenscontroller.cpp
    qtcompositor.cpp
    displayconfigurationpolicy.cpp
    wrappedwindowmanagementpolicy.cpp
 #   mirdisplayconfigurationobserver.cpp
    wayland-generated/qt-windowmanager_wrapper.cpp
    wayland-generated/server-decoration_wrapper.cpp
)
add_dependencies(qtmirserver-mirserver MirServer_LTTNG)

# These files get entangled by automoc so they need to go together. And some depend on mirserver-dev
set(QMIRSERVER_PLUGIN_SRC
    ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
    cursor.cpp
    eventbuilder.cpp
    qtwindowmanager.cpp
    qteventfeeder.cpp
    qmirserver.cpp
    qmirserver_p.cpp
    platformscreen.cpp
    screenplatformwindow.cpp
    screensmodel.cpp
    miropenglcontext.cpp
    offscreensurface.cpp
    inputdeviceobserver.cpp
    mirserverapplication.cpp
    windowmodelnotifier.cpp

    wayland/kwinserverdecoration.cpp

# We need to run moc on these headers
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirMousePointerInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/Mir.h

    ${CMAKE_SOURCE_DIR}/include/qtmir/mirserverapplication.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/displayconfigurationpolicy.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/sessionauthorizer.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/windowmanagementpolicy.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/displayconfigurationstorage.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/screen.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/screens.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/types.h
    ${CMAKE_SOURCE_DIR}/include/qtmir/qtmir.h

    ${CMAKE_SOURCE_DIR}/src/common/windowcontrollerinterface.h
    ${CMAKE_SOURCE_DIR}/src/common/workspacecontrollerinterface.h
    ${CMAKE_SOURCE_DIR}/src/common/windowmodelnotifier.h
    ${CMAKE_SOURCE_DIR}/src/common/appnotifier.h
)

if(NOT WITH_MIR2)
  set(MIROIL_OBJ $<TARGET_OBJECTS:miroil>)
endif()

add_library(qtmirserver SHARED
    ${QMIRSERVER_PLUGIN_SRC}
    $<TARGET_OBJECTS:qtmirserver-nomirserver>
    $<TARGET_OBJECTS:qtmirserver-mirserver>
    ${MIROIL_OBJ}
)

target_link_libraries(qtmirserver
    PUBLIC
        ${MIRAL_LDFLAGS}
        ${MIROIL_LDFLAGS}
        ${MIROIL_LIBRARIES}
        ${MIRSERVER_LDFLAGS}
        Qt5::Core
        Qt5::Gui

    PRIVATE
        Threads::Threads
        ${URL_DISPATCHER_LDFLAGS}
        ${EGL_LDFLAGS}
        ${LTTNG_LIBRARIES}
        ${GIO_LDFLAGS}
        ${FONTCONFIG_LDFLAGS}
        ${XKBCOMMON_LIBRARIES}

        ${MIRCOMMON_LDFLAGS}
        ${MIRWAYLAND_LDFLAGS}
        ${WAYLAND_CLIENT_LIBRARIES}
        ${WAYLAND_SERVER_LDFLAGS}

        ${CONTENT_HUB_LIBRARIES}

        Qt5::DBus
        Qt5::Quick
        Qt5::Sensors
        ${QT5PLATFORMSUPPORT_LIBS}
)

set_target_properties(qtmirserver
  PROPERTIES
  SOVERSION ${QTMIRSERVER_ABI}
)

set(LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}")
set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/qtmir")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qtmirserver.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/qtmirserver.pc
    @ONLY
)

install(
  TARGETS qtmirserver
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(
  DIRECTORY ${CMAKE_SOURCE_DIR}/include/qtmir
  DESTINATION "include/qtmir"
)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/qtmirserver.pc
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

if(NOT WITH_MIR2)
  # To avoid conflicts, we install to qtmir include
  # and since do -I/some/thing/qtmir in the .pc we can
  # include miroil as <miroil/blah>
  install(
    DIRECTORY ${CMAKE_SOURCE_DIR}/include/miroil
    DESTINATION "include/qtmir"
  )
endif()

add_library(qpa-mirserver SHARED
    mirserverintegration.cpp
    plugin.cpp
)

target_link_libraries(qpa-mirserver
PRIVATE
    qtmirserver
    ${QT5PLATFORMSUPPORT_LIBS}

    ${MIRSERVER_LDFLAGS}
    ${URL_DISPATCHER_LDFLAGS}
    ${EGL_LDFLAGS}
    ${LTTNG_LIBRARIES}
    ${GIO_LDFLAGS}
    ${FONTCONFIG_LDFLAGS}
    ${XKBCOMMON_LIBRARIES}

    ${CONTENT_HUB_LIBRARIES}

    Qt5::Core
    Qt5::DBus
    Qt5::Quick
    Qt5::Sensors
    Qt5::Qml
)

install(TARGETS qpa-mirserver LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/qt5/plugins/platforms")

=== tests/mirserver/Screen/CMakeLists.txt ===
set(
  SCREEN_TEST_SOURCES
  screen_test.cpp
  ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/tests/framework
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/common
)

include_directories(
  SYSTEM
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
)

add_executable(ScreenTest ${SCREEN_TEST_SOURCES})

target_link_libraries(
  ScreenTest
  qtmirserver

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}

  Qt5::Sensors
)

add_test(Screen, ScreenTest)

=== tests/mirserver/URLBuilderDispatcher/CMakeLists.txt ===
set(
  URLBUILDERDISPATCHER_TEST_RESOURCES
  urlbuilderdispatcher_test.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/tests/framework
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/common
)

include_directories(
  SYSTEM
  ${QT5PLATFORM_SUPPORT_INCLUDE_DIRS}
  ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
)

add_executable(URLBuilderDispatcherTest ${URLBUILDERDISPATCHER_TEST_RESOURCES})

target_link_libraries(
  URLBuilderDispatcherTest
  qtmirserver

  ${QT5PLATFORMSUPPORT_LIBS}
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(URLBuilderDispatcher, URLBuilderDispatcherTest)

=== tests/modules/Session/CMakeLists.txt ===
set(
  SESSION_TEST_SOURCES
  taskcontroller_test.cpp
  session_test.cpp
  ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include
  ${CMAKE_SOURCE_DIR}/src/modules
  ${CMAKE_SOURCE_DIR}/tests/framework
)

include_directories(
  SYSTEM
  ${APPLICATION_API_INCLUDE_DIRS}
  ${MIRAL_INCLUDE_DIRS}
  ${MIROIL_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
)

add_executable(session_test ${SESSION_TEST_SOURCES})

add_dependencies(session_test qtmir-test-framework-static)

target_link_libraries(
  session_test

  qtmirapplicationplugin

  Qt5::Test

  -L${CMAKE_BINARY_DIR}/tests/framework
  qtmir-test-framework-static

  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(Session, session_test)

=== tests/modules/WindowManager/CMakeLists.txt ===
set(
  MIR_WINDOW_MANAGER_TEST_SOURCES
#  mirsurfaceitem_test.cpp #FIXME - reinstate these tests when functionality there
  mirsurface_test.cpp
  windowmodel_test.cpp
  ${CMAKE_SOURCE_DIR}/src/common/debughelpers.cpp
)

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/src/common
  ${CMAKE_SOURCE_DIR}/src/modules
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
  ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include
  ${CMAKE_SOURCE_DIR}/tests/framework
)

include_directories(
  SYSTEM
  ${MIRAL_INCLUDE_DIRS}
  ${MIRTEST_INCLUDE_DIRS}
  ${MIROIL_INCLUDE_DIRS}
  ${MIRSERVER_INCLUDE_DIRS}
  ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
)

add_executable(windowmanager_test ${MIR_WINDOW_MANAGER_TEST_SOURCES})

target_link_libraries(
  windowmanager_test

  qtmirapplicationplugin

  Qt5::Test

  -L${CMAKE_BINARY_DIR}/miral-qt/tests/framework
  qtmir-test-framework-static

  ${MIRAL_LDFLAGS}
  ${MIRTEST_LDFLAGS}
  ${GTEST_BOTH_LIBRARIES}
  ${GMOCK_LIBRARIES}
)

add_test(WindowManager windowmanager_test)

=== src/modules/QtMir/Application/CMakeLists.txt ===
include(UseLttngGenTp)

if(NOT WITH_MIR2)
 set(MIROIL_INC ${CMAKE_SOURCE_DIR}/src/platforms/mirserver/miroil/include)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/src/platforms/mirserver
    ${MIROIL_INC}
    ${CMAKE_SOURCE_DIR}/src/common
    ${CMAKE_CURRENT_BINARY_DIR} # for tracepoints.h
)

include_directories(
    SYSTEM
    ${GLIB_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${GIO_UNIX_INCLUDE_DIRS}
    ${MIRAL_INCLUDE_DIRS}
    ${MIRSERVER_INCLUDE_DIRS}
    ${MIROIL_INCLUDE_DIRS}
    ${MIRRENDERERGLDEV_INCLUDE_DIRS}
    ${PROCESS_CPP_INCLUDE_DIRS}
    ${UBUNTU_PLATFORM_API_INCLUDE_DIRS}
    ${LOMIRI_APP_LAUNCH_INCLUDE_DIRS}
    ${GSETTINGS_QT_INCLUDE_DIRS}

    ${LTTNG_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${Qt5Qml_PRIVATE_INCLUDE_DIRS}
    ${Qt5Quick_PRIVATE_INCLUDE_DIRS}
)

# We have to remove -pedantic in order to compile tracepoints.c
string (REPLACE " -pedantic " " " CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
# Needed to compile tracepoints in C99 mode.
add_definitions(-DBYTE_ORDER=__BYTE_ORDER)

# Generate tracepoints.c and .h from tracepoints.tp
add_lttng_gen_tp(NAME tracepoints)
add_custom_target(QtMirApplication_LTTNG
    DEPENDS tracepoints.h tracepoints.c
)

set(QMLMIRPLUGIN_SRC
    application_manager.cpp
    application.cpp
    compositortextureprovider.cpp
    ../../../common/abstractdbusservicemonitor.cpp
    ../../../common/debughelpers.cpp
    dbusfocusinfo.cpp
    plugin.cpp
    mirsurface.cpp
    mirsurfaceinterface.h
    mirsurfaceitem.cpp
    mirsurfacelistmodel.cpp
    mirbuffersgtexture.cpp
    proc_info.cpp
    session.cpp
    sharedwakelock.cpp
    surfacemanager.cpp
    taskcontroller.cpp
    lal/applicationinfo.cpp
    lal/taskcontroller.cpp
    timer.cpp
    timesource.cpp
    tracepoints.c
    settings.cpp
    windowmodel.cpp
# We need to run moc on these headers
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationInfoInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/ApplicationManagerInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/Mir.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceItemInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/MirSurfaceListInterface.h
    ${APPLICATION_API_INCLUDEDIR}/lomiri/shell/application/SurfaceManagerInterface.h
# Feed the automoc monster
    session_interface.h
    applicationinfo.h
    taskcontroller.h
    settings_interface.h
)

add_library(qtmirapplicationplugin SHARED
    ${QMLMIRPLUGIN_SRC}
)
add_dependencies(qtmirapplicationplugin QtMirApplication_LTTNG)

# Frig for files that still rely on mirserver-dev
string(REPLACE ";" " -I" QTMIR_ADD_MIRSERVER "-I ${MIRSERVER_INCLUDE_DIRS}")
set_source_files_properties(mirsurface.cpp         PROPERTIES COMPILE_FLAGS "${CMAKE_CXXFLAGS} ${QTMIR_ADD_MIRSERVER}")

target_link_libraries(
    qtmirapplicationplugin

    ${CMAKE_THREAD_LIBS_INIT}

    ${GLIB_LDFLAGS}
    ${UBUNTU_PLATFORM_API_LDFLAGS}
    ${MIRSERVER_LDFLAGS}
    ${PROCESS_CPP_LDFLAGS}
    ${LOMIRI_APP_LAUNCH_LDFLAGS}
    ${LTTNG_LDFLAGS}
    ${GSETTINGS_QT_LDFLAGS}

    Qt5::Core
    Qt5::DBus
    Qt5::Qml
    Qt5::Quick

    qtmirserver
)


# install
add_qml_plugin(QtMir.Application 0.1 QtMir/Application TARGETS qtmirapplicationplugin)
install(FILES com.canonical.qtmir.gschema.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/glib-2.0/schemas)

=== debian/changelog ===
qtmir (0.8.0~git20250407.ea2f477-7) unstable; urgency=medium

  * debian/control:
    + Add to D: (qtmir): qtwayland5. Assure that the wayland platform plugin
      for Qt5 is available. QtMir / Lomiri session / shell will not come up
      otherwise. Thanks to Oren Klopfer for discovering and reporting this.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 13 Nov 2025 07:38:25 +0100

qtmir (0.8.0~git20250407.ea2f477-6) unstable; urgency=medium

  * debian/rules:
    + Update get-orig-source target. Assure that always that Git snapshot
      is retrieved that is referenced at the top of the d/changelog file.
  * debian/patches:
    + Disable 0023_src-platforms-Select-GLRenderingProvider-based-on-
      suitability.patch. It causes Lomiri to crash when launching apps.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Oct 2025 16:15:03 +0200

qtmir (0.8.0~git20250407.ea2f477-5) unstable; urgency=medium

  * debian/patches:
    + Add 0023_src-platforms-Select-GLRenderingProvider-based-on-
      suitability.patch. Support Lomiri on Asahi Linux.
    + Add 0030_mirserver-update-for-Mir-2.22.patch, 0031_demos-drop-usage-
      of-deprecated-Descriptors.patch and 0032_mirsurface-add-
      mirror_mode_set_to.patch. Support building and being used with Mir
      2.22.x.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Oct 2025 09:29:18 +0200

qtmir (0.8.0~git20250407.ea2f477-4) unstable; urgency=medium

  * debian/patches:
    + Add 0001_Bump-minimum-required-CMake-version.patch. Support building with
      CMake 4. (Closes: #1113450).
  * debian/copyright:
    + Update FSF mailing address.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 07 Sep 2025 18:41:03 +0200

qtmir (0.8.0~git20250407.ea2f477-3) unstable; urgency=medium

  * debian/patches:
    + Revert "debian/patches: Add 0001_mirserver-cursor-take-Shell-s-rotation-
      into-account.patch. Fix cursor positioning if display is rotated."
    + Revert "debian/patches: Add 0013_src-modules-Address-review-comments-for-
      MirSurface.patch, 0014_src-modules-Set-MirSurface-live-to-false-when-
      tearin.patch, 0015_src-modules-Use-explicit-signal-to-signify-a-
      teardow.patch, 0016_src-modules-Drop-references-before-teardown.patch.
      Address crash-on-close issue for windows with the same APP_ID (causing
      Lomiri shell to crash). This goes together with a changeset in lomiri
      src:pkg."
    + Add 0022_modules-MirSurface-try-to-let-Mir-forceClose-dead-su.patch.
      Attempt at forceClosing dead surfaces.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 10 Aug 2025 16:23:38 +0200

qtmir (0.8.0~git20250407.ea2f477-2) unstable; urgency=medium

  * debian/patches:
    + Add 0001_mirserver-cursor-take-Shell-s-rotation-into-account.patch. Fix
      cursor positioning if display is rotated.
    + Add 0009_src-modules-Add-header-for-getpid.patch. Add include for getpid()
      function.
    + Add 0002_src-modules-Re-introduce-lost-workaround-for-font-re.patch.
      Regression fix, fix arbitrary font rendering glitches. (LP:#1583088).
    + Add 0011_src-platforms-Wrap-window-activity-change-in-a-try-c.patch.
      Selecting the active window can lead to a range exception, so avoid a
      crash by wrapping this in a try-catch.
    + Add 0012_src-modules-Partial-revert-of-e73ef71622ad3202b77bf6.patch. Drop
      overzealous code when removing a window.
    + Add 0013_src-modules-Address-review-comments-for-MirSurface.patch,
      0014_src-modules-Set-MirSurface-live-to-false-when-tearin.patch, 0015_src-
      modules-Use-explicit-signal-to-signify-a-teardow.patch, 0016_src-modules-
      Drop-references-before-teardown.patch. Address crash-on-close issue for
      windows with the same APP_ID (causing Lomiri shell to crash). This goes
      together with a changeset in lomiri src:pkg.
    + Trivial rebase of 2003_disable-benchmarks.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 30 Jul 2025 15:21:45 +0200

qtmir (0.8.0~git20250407.ea2f477-1) unstable; urgency=medium

  * New upstream Git snapshot.
    - Fix Lomiri shell crashes when connecting an external display.
  * debian/copyright:
    + Update copyright attributions for debian/.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 17 Apr 2025 21:25:11 +0200

qtmir (0.8.0~git20250319.5ab362a-1) unstable; urgency=medium

  [ Alan Griffiths ]
  * New upstream Git snapshot.
    - src/platforms/mirserver/wrappedwindowmanagementpolicy.cpp: Forward call to
      WindowManagementPolicy::advise_delete_window() to MinimalWindowManager::
      advise_delete_window(). This fixes shell crashes on app closure.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 28 Mar 2025 08:23:01 +0100

=== debian/control ===
Source: qtmir
Section: libs
Priority: optional
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <mariogrip@debian.org>,
Build-Depends: cmake,
               cmake-extras (>= 1.6~),
               debhelper-compat (= 13),
               googletest (>= 1.10.0),
               libfontconfig-dev,
               libgles2-mesa-dev,
               libglib2.0-dev,
               libgsettings-qt-dev,
               libgtest-dev,
               liblttng-ust-dev,
               libmiral-dev (>= 3.0),
               libmircommon-dev (>= 2.20.0~),
               libmirserver-dev (>= 2.20.0~),
               libmtdev-dev,
               libprocess-cpp-dev (>= 3.0.2),
               libqt5sensors5-dev,
               libqtdbusmock1-dev (>= 0.2),
               libqtdbustest1-dev (>= 0.2),
               liblomiri-app-launch-dev,
               libudev-dev,
               liblomiri-api-dev (>= 0.2.0),
               liblomiri-content-hub-dev (>= 2.0.0),
               liblomiri-url-dispatcher-dev,
               libxkbcommon-dev,
               libxrender-dev,
               mir-renderer-gl-dev (>= 2.20.0~),
               mirtest-dev (>= 2.20.0~),
               libmiroil-dev (>= 2.20.0~),
               libmirwayland-dev (>= 2.20.0~),
               pkgconf,
# lttng-gen-ts needs python3, but doesn't depend on it itself: bug 1359147
               python3:any,
               qtbase5-dev,
               qtbase5-private-dev,
               qtdeclarative5-dev,
               qtdeclarative5-private-dev,
               quilt,
               valgrind-if-available,
# libmirserver-dev should have brought this dep. Bug lp:1617435
               uuid-dev,
# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
               libboost-filesystem-dev,
               libboost-system-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/qtmir
Vcs-Git: https://salsa.debian.org/ubports-team/qtmir.git
Vcs-Browser: https://salsa.debian.org/ubports-team/qtmir

Package: qtmir
Architecture: linux-any
Multi-Arch: same
Breaks: qtmir-android (<< 0.7.0~),
        qtmir-desktop (<< 0.7.0~),
Replaces: qtmir-android (<< 0.7.0~),
          qtmir-desktop (<< 0.7.0~),
Depends: ${misc:Depends},
         ${shlibs:Depends},
         qtwayland5,
Description: Qt platform abstraction (QPA) plugin for a Mir server
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.

Package: qtmir-android
Architecture: armhf arm64
Multi-Arch: same
Depends: qtmir, ${misc:Depends},
Section: oldlibs
Description: QPA plugin for a Mir server (mobile, transitional package)
  QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
  It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
  a Mir server. It also exposes some internal Mir functionality.
 .
 This variant of the package is for Android-based phones and tablets.
 .
 This is a transitional package. It can safely be removed.

Package: qtmir-desktop
Architecture: linux-any
Multi-Arch: same
Depends: qtmir, ${misc:Depends},
Section: oldlibs
Description: QPA plugin for a Mir server (desktop, transitional package)
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This variant of the package is for GNU-based desktops.
 .
 This is a transitional package. It can safely be removed.

Package: libqtmirserver-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: qtmir (= ${binary:Version}),
         ${misc:Depends},
         libmiral-dev (>= 3.0),
         libmiroil-dev,
         libmirserver-dev,
Description: Developer files for QtMir server API
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This package contains the library headers for developers.

Package: libqtmirserver2
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
      ${shlibs:Depends},
Description: QtMir server API shared library
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 Contains the shared library containing QtMir server API.

Package: qml-module-qtmir
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: qtmir (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Provides: lomiri-application-impl,
          lomiri-application-impl-27,
Description: Qt/QML module for Lomiri specific Mir APIs
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 QtMir provides Qt/QML bindings for Mir features that are exposed through the
 qtmir QPA plugin such as Application management (start/stop/suspend/resume)
 and surface management.

Package: qtmir-tests
Section: libdevel
Architecture: linux-any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends},
Depends: littler,
         lttng-tools,
         mir-test-tools,
         qml-module-lomiri-components,
         qml-module-qtmir,
         qtmir (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: QtMir tests and demos
 QtMir is a set of Qt5 components to enable one to write a Mir server with Qt.
 It contains a QPA (Qt Platform Abstraction) plugin which creates and manages
 a Mir server. It also exposes some internal Mir functionality.
 .
 This package provides benchmark tests and a simple shell and client using the
 QtMir QPA.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to be more picky with non-updated .symbols files
#export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/default.mk

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

FLAGS := -DWITH_CONTENTHUB=ON -DWerror=OFF -DWITH_MIR2=on

# Explicitly disable building with Valgrind on architectures without it.
# If valgrind is available or not gets decided via the valgrind-if-available
# virtual package.
ifeq (, $(shell command -v valgrind))
	FLAGS += -DWITH_VALGRIND=OFF
endif

override_dh_auto_configure:
	dh_auto_configure -- $(FLAGS)

override_dh_install:
	#clean gmock/gtest if it built in our build dir
	-rm -f debian/tmp/usr/lib/libgmock*.a debian/tmp/usr/lib/libgtest*.a
	-rm -rf debian/tmp/usr/include/gmock debian/tmp/usr/include/gtest
	dh_install

include /usr/share/dpkg/pkg-info.mk

PKD   = $(word 1,$(abspath $(dir $(MAKEFILE_LIST))))
PKG   = $(DEB_SOURCE)
UVER  = $(shell echo $(DEB_VERSION) | cut -d "-" -f1)
DTYPE =
VER  ?= $(subst $(DTYPE),,$(UVER))

UURL = https://gitlab.com/ubports/development/core/qtmir.git
UREV = $(shell echo $(VER) | cut -d"." -f4)

## http://wiki.debian.org/onlyjob/get-orig-source
.PHONY: get-orig-source
get-orig-source: $(PKG)_$(VER)$(DTYPE).orig.tar.xz $(info I: $(PKG)_$(VER)$(DTYPE))
	@

$(PKG)_$(VER)$(DTYPE).orig.tar.xz: $(info I: GIT Revision=$(UREV))
	$(if $(wildcard $(PKG)-$(VER)),$(error $(PKG)-$(VER) exist, aborting..))
	@echo "# Downloading..."
	git clone $(UURL) $(PKG)-$(VER) \
	   || $(RM) -r $(PKG)-$(VER)
	cd $(PKG)-$(VER) \
	   && git checkout "$(UREV)" \
	   && ( echo "# Generating ChangeLog..." \
	      ; git --no-pager log --format="%ai %aN (%h) %n%n%x09*%w(68,0,10) %s%n" > ChangeLog \
	      ; touch -d "$$(git log -1 --format='%ci')" ChangeLog) \
	   && echo "# Setting times..." \
	   && for F in $$(git ls-tree -r --name-only HEAD); do touch --no-dereference -d "$$(git log -1 --format="%ai" -- $$F)" "$$F"; done \
	   && echo "# Cleaning-up..." \
	   && rm -rf .git .git*
	@echo "# Packing..."
	find -L "$(PKG)-$(VER)" -xdev -type f -print | sort \
	   | XZ_OPT="-6v" tar -caf "../$(PKG)_$(VER)$(DTYPE).orig.tar.xz" -T- --owner=root --group=root --mode=a+rX \
	   && $(RM) -r "$(PKG)-$(VER)"

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,  pretty=0.8.0~git%cd.%h" \
https://gitlab.com/ubports/development/core/qtmir.git \
heads/personal/sunweaver/debian-upstream debian

## qtmir 0.8.0~git20260226.fb30a11

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.10)
 
 project(qtmir)
 
@@ -86,7 +86,7 @@
 else()
 pkg_check_modules(MIRCLIENT mirclient>=0.26 REQUIRED)
 endif()
-pkg_check_modules(MIRRENDERERGLDEV mir-renderer-gl-dev>=0.26 REQUIRED)
+pkg_check_modules(MIRRENDERERGLDEV mir-renderer-gl-dev>=0.26)
 pkg_check_modules(MIRAL miral>=1.1.0 REQUIRED)
 pkg_check_modules(MIRWAYLAND mirwayland REQUIRED)
 pkg_check_modules(WAYLAND_CLIENT REQUIRED wayland-client)
@@ -102,8 +102,6 @@
 pkg_check_modules(GIO_UNIX gio-unix-2.0)
 pkg_check_modules(LTTNG lttng-ust)
 pkg_check_modules(GSETTINGS_QT REQUIRED gsettings-qt)
-pkg_check_modules(QTDBUSTEST libqtdbustest-1 REQUIRED)
-pkg_check_modules(QTDBUSMOCK libqtdbusmock-1 REQUIRED)
 pkg_check_modules(APPLICATION_API REQUIRED lomiri-shell-application=28)
 
 if(WITH_VALGRIND)
@@ -132,19 +130,10 @@
 include(GNUInstallDirs)
 
 
-# Determine QPA plugin install path
-# FIXME(greyback) there must be a better way than calling a private macro to set a property.
-# I'm manually calling a macro from Qt5GuiConfig.cmake, but I don't understand why it isn't being called.
-if (Qt5Gui_VERSION VERSION_LESS 5.14.0)
-  _populate_Gui_plugin_properties("Gui" "PLATFORMS" "platforms")
-else()
-  _populate_Gui_plugin_properties("Gui" "PLATFORMS" "platforms" FALSE)
-endif()
-get_target_property(Qt5Gui_QPA_Plugin_Path Qt5::Gui IMPORTED_LOCATION_PLATFORMS)
-
 # Set QML module install path
-set(QML_MODULE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/qt5/qml")
-set(QTMIR_DATA_DIR ${CMAKE_INSTALL_DATADIR}/qtmir)
+set(QML_MODULE_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/qt5/qml")
+set(QTMIR_DATA_DIR ${CMAKE_INSTALL_FULL_DATADIR}/qtmir)
+set(QPA_PLUGIN_INSTALL_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/qt5/plugins/platforms")
 
 
 # Customisations for the build type
@@ -158,7 +147,7 @@
 if(cmake_build_type_lower MATCHES relwithdebinfo) # workaround for http://public.kitware.com/Bug/view.php?id=14696
     add_definitions(-DQT_NO_DEBUG)
 endif()
-if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
+if ("${cmake_build_type_lower}" STREQUAL "release" OR "${cmake_build_type_lower}" STREQUAL "relwithdebinfo")
     option(Werror "Treat warnings as errors" ON)
 else()
     option(Werror "Treat warnings as errors" OFF)
@@ -177,6 +166,9 @@
 if (NO_TESTS OR WITH_MIR2)
     message(STATUS "Tests disabled")
 else()
+    pkg_check_modules(QTDBUSTEST libqtdbustest-1 REQUIRED)
+    pkg_check_modules(QTDBUSMOCK libqtdbusmock-1 REQUIRED)
+
     include(CTest)
     enable_testing()
     add_subdirectory(tests)

=== data/CMakeLists.txt ===
install(FILES xwayland.qtmir.desktop
	DESTINATION ${CMAKE_INSTALL_DATADIR}/applications
)

install(FILES xwayland.qtmir.png
        DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/512x512/apps
)

=== src/platforms/mirserver/CMakeLists.txt ===
--- 
+++ 
@@ -42,6 +42,9 @@
     Qt5ServiceSupport::Qt5ServiceSupport
 )
 
+find_package(Freetype REQUIRED)
+pkg_check_modules(HARFBUZZ REQUIRED harfbuzz)
+
 include_directories(
     ${CMAKE_SOURCE_DIR}/include
     ${CMAKE_SOURCE_DIR}/src/common
@@ -81,6 +84,8 @@
 
     ${VALGRIND_INCLUDE_DIRS}
 )
+
+include_directories(SYSTEM ${HARFBUZZ_INCLUDE_DIRS})
 
 # We have to remove -pedantic for tracepoints.c
 string (REPLACE " -pedantic " " " TRACEPOINTS_CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
@@ -217,6 +222,8 @@
         Qt5::Quick
         Qt5::Sensors
         ${QT5PLATFORMSUPPORT_LIBS}
+        Freetype::Freetype
+        ${HARFBUZZ_LIBRARIES}
 )
 
 set_target_properties(qtmirserver
@@ -225,7 +232,7 @@
 )
 
 set(LIBDIR "${CMAKE_INSTALL_FULL_LIBDIR}")
-set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/qtmir")
+set(INCLUDEDIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/qtmir")
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qtmirserver.pc.in
     ${CMAKE_CURRENT_BINARY_DIR}/qtmirserver.pc
@@ -285,4 +292,4 @@
     Qt5::Qml
 )
 
-install(TARGETS qpa-mirserver LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}/qt5/plugins/platforms")
+install(TARGETS qpa-mirserver LIBRARY DESTINATION "${QPA_PLUGIN_INSTALL_DIR}")

=== debian/changelog ===
qtmir (0.8.0~git20260226.fb30a11-2) unstable; urgency=medium

  * debian/control:
    + Enforce rebuild against Mir 2.25.x.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 01 Mar 2026 20:42:48 +0100

qtmir (0.8.0~git20260226.fb30a11-1) unstable; urgency=medium

  * New upstream Git snapshot.
    - Fix scaling of Lomiri via GRID_UNIT_PX env variable. (Reverted by patch).
    - Find FreeType via CMake, HarfBuzz via pkg-config.
    - Fix running on Asahi Linux.
  * debian/patches:
    + Drop 0002_src-modules-Re-introduce-lost-workaround-for-font-re.patch,
      0009_src-modules-Add-header-for-getpid.patch, 0011_src-platforms-Wrap-
      window-activity-change-in-a-try-c.patch, 0012_src-modules-Partial-revert-
      of-e73ef71622ad3202b77bf6.patch, 0022_modules-MirSurface-try-to-let-Mir-
      forceClose-dead-su.patch, 0001_Bump-minimum-required-CMake-version.patch
      and 0023_src-platforms-Select-GLRenderingProvider-based-on-
      suitability.patch. All addressed upstream.
    + Rebase 2003_disable-benchmarks.patch.
    + Add 0033_Revert-src-platforms-Fix-synchronization-bug-with-Mi.patch.
      Revert scaling fix as it breaks mouse pointer and keyboard.
  * debian/control:
    + Add B-D: libharfbuzz-dev.
  * debian/copyright:
    + Update copyright attributions.
  * debian/qml-module-qtmir.install:
    + xwayland.qtmir.png icon has change size.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 27 Feb 2026 18:03:22 +0100

qtmir (0.8.0~git20250407.ea2f477-8) unstable; urgency=medium

  * Team upload

  [ Thorsten Alteholz ]
  * Use salsa-ci.yml instead of .gitlab-ci.yml

  [ Jeremy Bícha ]
  * Remove unnecessary direct Build-Depends: libboost-filesystem-dev,
    libboost-system-dev, uuid-dev (Closes: #1127264)
  * Update Standards Version to 4.7.3

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 20 Feb 2026 12:51:33 -0500

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: qtmir
 Section: libs
-Priority: optional
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>,
@@ -15,10 +14,11 @@
                libglib2.0-dev,
                libgsettings-qt-dev,
                libgtest-dev,
+               libharfbuzz-dev,
                liblttng-ust-dev,
                libmiral-dev (>= 3.0),
-               libmircommon-dev (>= 2.20.0~),
-               libmirserver-dev (>= 2.20.0~),
+               libmircommon-dev (>= 2.25.0~),
+               libmirserver-dev (>= 2.25.0~),
                libmtdev-dev,
                libprocess-cpp-dev (>= 3.0.2),
                libqt5sensors5-dev,
@@ -33,8 +33,8 @@
                libxrender-dev,
                mir-renderer-gl-dev (>= 2.20.0~),
                mirtest-dev (>= 2.20.0~),
-               libmiroil-dev (>= 2.20.0~),
-               libmirwayland-dev (>= 2.20.0~),
+               libmiroil-dev (>= 2.25.0~),
+               libmirwayland-dev (>= 2.25.0~),
                pkgconf,
 # lttng-gen-ts needs python3, but doesn't depend on it itself: bug 1359147
                python3:any,
@@ -44,13 +44,7 @@
                qtdeclarative5-private-dev,
                quilt,
                valgrind-if-available,
-# libmirserver-dev should have brought this dep. Bug lp:1617435
-               uuid-dev,
-# mirtest pkgconfig requires these, but doesn't have a deb dependency. Bug lp:1633537
-               libboost-filesystem-dev,
-               libboost-system-dev,
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://gitlab.com/ubports/development/core/qtmir
 Vcs-Git: https://salsa.debian.org/ubports-team/qtmir.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/qtmir
